-------------- Definition when using GCC on a i386 architecture --------------

Provide(gcc-i386)
Require(gcc)

------ What *you* can configure ------
Define this if you're sure nobody'll ever wanna run your binary on a 386:
	undefine(__ASSUME_486__)


------ Various Sizes ------

We are little-endian:	define({__BYTE_ORDER},1234)

We can use half words:		define({__HAS_HALFWORD__})
We can use 64 bit words:	define({__HAS_UINT64__})
We can use 32 bit words:	define({__HAS_UINT32__})
We can use 16 bit words:	define({__HAS_UINT16__})
We can use 8 bit words:		define({__HAS_UINT8__})
We can access unaligned data:	define({__HAS_UNALIGNED_ACCESS__})


define({__C_ARCHDEP_TYPE_DEFINITIONS__},{

typedef	unsigned char		uint8 ;
typedef	signed char		int8 ;
typedef unsigned short		uint16 ;
typedef signed short		int16 ;
typedef unsigned long		uint32 ;
typedef signed long		int32 ;
typedef unsigned long long	uint64 ;
typedef signed long long	int64 ;

typedef uint8	Byte ;
typedef uint16	HalfWord ;
typedef uint32	Word ;

})




------ Inline assembly... ------

In inline asm statements, i386-specific constraints are:
`a'	EAX
`b'	EBX
`c'	ECX
`d'	EDX
`S'	ESI
`D'	EDI
`B'	EBP

else see *C Extensions:: section in gcc.info* files.
})



--- Byte swapping


define({__C_DEFINE_BYTESWAP__},{

__inline__ static uint32 swap_4_bytes(uint32 x)
BEGIN
	asm(
	    ifdef({__ASSUME_486__},{
		"bswap %0"     /* use bswap instruction */
	    },{
		"xchgb %b0,%h0\n\t"     /* swap lower bytes     */
		"rorl $ 16,%0\n\t"       /* swap low and high words */
		"xchgb %b0,%h0"         /* swap ex-higher now-lower bytes */
	    })
	  :"=q" (x)
	  : "0" (x));
	return x;
END
__inline__ static uint16 swap_2_bytes(uint16 x)
BEGIN
	asm(
		"xchgb %b0,%h0\n\t"     /* swap lower bytes     */
	  :"=q" (x)
	  : "0" (x));
	return x;
END

})
