dnl ----------------------=|=--- debug.m4 ---=|=-----------------------------
dnl --=-- Debugging routines for the i386 --=---
dnl
dnl
dnl Lots of info taken from the sources of the Linux console driver.
dnl
Provide({debug},{
dnl
dnl
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Debugging ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

define({SHOWL},{zzz({
	push esi
	lsa(esi,$@,0)
	call ShowLine
	pop esi
})})
define({DLINE},{zzz({mov [pmaddr(DumpLine)],#$1
})})
define({PSST},{zzz({pushing(ad,{call Input_Char
})})})

pmpart

__stringseg__({


define({NamedDump},{
	.ascii "$1="
	.byte 0,$2,$3})

ERegs_DumpLayout:
	irp(X,{
{EAX,8,3},     {EBX,8,3},     {ECX,8,3},     {EDX,8,5},       {EIP,8,6}, 
{ESI,8,3},     {EDI,8,3},     {EBP,8,3},     {ESP,8,5},       {EFLAGS,8,3},
{CS,4,2}, {DS,4,2}, {ES,4,2}, {FS,4,2}, {GS,4,2}, {SS,4,10},  {ERRNUM,8,3}},
	{NamedDump(X)})


define({DumpDescr},{
	.byte ifelse({$2},{},{sizeof_$1/4},{+ ($2)})
	irp(reg,{EAX,EBX,ECX,EDX,EIP,ESI,EDI,EBP,ESP,EFLAGS,
		CS,DS,ES,FS,GS,SS},{.byte $1_{}reg
})ifelse($#,1,{},$#,2,{},{.byte shift(shift($@))})})


Struc({INTSTACK_D},{
  irp(reg,
	{ES,DS,FS,GS,
	 EDI,ESI,EBP,aESP,EBX,EDX,ECX,EAX,
	 ERROR,EIP,CS,EFLAGS,ESP,SS},
	{_long_(reg)})})
Struc({ERegs_D},{
  irp(reg,
	{EDI,ESI,EBP,ESP,EBX,EDX,ECX,EAX,
	 EFLAGS,CS,DS,ES,FS,GS,SS,EIP},
	{_long_(reg)})})


ERegs_DumpDescr:	DumpDescr({ERegs_D},16)
V86INT_DumpDescr:	DumpDescr({V86INT},16)
INTSTACK_DumpDescr:	DumpDescr({INTSTACK_D},17)


})


__dataseg__({
})

__udataseg__({

DumpLine = alallot(u,4)

})

__codeseg__({



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Subroutines ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sleep_1s:
	STOP(fs,0xB8000,79,1,'1,0x70)
	push ecx
	mov ecx,#0x10000
 s1s:
	STOP(fs,0xB8000,79,2,'=,0x70)
zzzzz({
	pushad
	mov edi,[pmaddr(Video_mem_base)]
	add edi,#(70+2*80)*2
	mov edx,ecx
	mov ecx,#8
	mov ah,#0x07
	;call DumpHex
	popad
})
	STOP(fs,0xB8000,79,2,'+,0x70)
	loop s1s
	pop ecx
	STOP(fs,0xB8000,79,2,'s,0x70)
	ret

sleep:
	pushad
	mov edi,[pmaddr(Video_mem_base)]
	add edi,#(70+80)*2
	mov edx,ecx
	mov ecx,#8
	mov ah,#0x07
	call DumpHex
	popad
	STOP(fs,0xB8000,79,1,'R,0x70)
	call sleep_1s
	STOP(fs,0xB8000,79,1,'Z,0x70)
	call sleep_1s
	loop sleep
	STOP(fs,0xB8000,79,1,'Z,0x07)
	ret



DumpERegs:
	;STOP(fs,0xB8000,75,20,'E,0x07)
   ;;; Push data to dump:
	pushm(ad,fd,cs,ds,es,fs,gs,ss)
	add [esp+ERegs_D_ESP],#sizeof_ERegs_D-sizeof_PUSHAD
	;STOP(fs,0xB8000,76,20,'R,0x07)
   ;;; Use MyDump
	mov esi,#pmaddr(ERegs_DumpLayout)
	mov ebp,#pmaddr(ERegs_DumpDescr)
	mov ebx,esp
	;STOP(fs,0xB8000,77,20,'e,0x07)
	call MyDump
	;STOP(fs,0xB8000,78,20,'g,0x07)
   ;;; Done
	popm(ad,fd,ds,ds,es)
	lea esp,[esp+12] ; do not modify flags !
	;STOP(fs,0xB8000,79,20,'s,0x07)
	ret

DumpV86INT:
	STOP(fs,0xB8000,0,22,'V,0x07)
	pushad
	mov esi,#pmaddr(ERegs_DumpLayout)
	mov ebp,#pmaddr(V86INT_DumpDescr)
	STOP(fs,0xB8000,1,22,'8,0x07)
	call MyDump
	popad
	STOP(fs,0xB8000,2,22,'6,0x07)
	ret

DumpINTSTACK:
	mov esi,#pmaddr(ERegs_DumpLayout)
	mov ebp,#pmaddr(INTSTACK_DumpDescr)
	lea ebx,[esp+4]
	call MyDump
	ret

;;;;; Dump some commented data to screen
MyDump:
; esi: a layout table
; ebp: a dump parameter description table
; ebx: parameter
	;STOP(fs,0xB8000,0,21,'M,0x07)
   ;;; Setup Segments Registers
	ppmov(ds,ss)
	ppmov(es,ds)
	cld
	;STOP(fs,0xB8000,1,21,'S,0x07)
   ;;; Point to the current screen lines to output to
	STOP(fs,0xB8000,2,21,'V,0x07)
	Mov(eax,3)
	call GetLines
	;STOP(fs,0xB8000,3,21,'B,0x07)
   ;;; Loop
	mov ah,#0x07		; video attribute
	movzx ecx,byte [ebp]	; number of values to show
	inc ebp
	;STOP(fs,0xB8000,4,21,'0,0x07)
Loopno0({pushing({ecx},{
	;STOP(fs,0xB8000,5,21,'L,0x07)
     ;;; Show Texts
	call DumpString
	;STOP(fs,0xB8000,6,21,'S,0x07)
     ;;; Show Hex Number
	movzx ecx,byte [ebp]	; offset of the value to show
	inc ebp
	mov edx,[ebx+ecx]	; value to show
	pushing({ecx},{
	  lodsb			; number of digits for the value
	  mov cl,al		; (high of ecx zeroed above)
	  call DumpHex
	})
	;STOP(fs,0xB8000,7,21,'H,0x07)
     ;;; Show spaces
	__IF__(necxz)
	  lodsb
	  mov cl,al
	__THEN__
	  mov al,#0x20
	  rep
	  stosw
	__ENDIF__
	;STOP(fs,0xB8000,8,21,'S,0x07)
	})
})
	;STOP(fs,0xB8000,8,21,'P,0x07)
	ret
;DumpRoutineTable:
;	.long	0,DumpWord,DumpLong


DumpString0:
	stosw
DumpString:
;; Dumps a 0-terminated string on screen, with attribute being ah.
	lodsb
	setf(al)
	jnz DumpString0
	ret

DumpZone:
;;Input:
;; ebx: byte intervals between numbers
;; ecx: number of numbers to show
;; esi: first number to show in the zone
;; edi: position in video buffer in which to show
;; ebp: number of digits to show
;; ah: video attribute
;; cld assumed
;;Output:
;;; print hex numbers in a zone
;;; spaces are printed between numbers
;; ecx,ebx,edx,ebp,eax conserved
;; esi,edi updated
	pushing({ecx},{
	  mov edx,[esi]
	  mov ecx,ebp
	  call DumpHex
	  add esi,ebx
	})
	pushing({ecx,eax},{
	dec ecx
	Loop({pushing({ecx},{
	  mov al,#0x20
	  stosw
	  mov edx,[esi]
	  mov ecx,ebp
	  call DumpHex
	  add esi,ebx
	})})})
	ret

DumpHex:
;;Input:
;; edx: hex number to dump
;; ecx: number of hex digits
;; edi: video buffer position
;; ah: video attribute
;;Output:
;; all gregister saved but edi
;; edi: ends right after the last character
	lea edi,[edi+ecx*2]
pushing({eax,ecx,edx,edi},{
   Loopno0({
	dec edi
	dec edi
	mov al,dl
	and al,#0x0F
	add al,#0x30
	Ifcompare(ae,al,#0x3A,{add al,#0x41-0x3A})
	mov [edi],ax
	shr edx,#4
})})
	ret



;;;; Print 17 dwords from esi
ShowDZone:
	pushing(ad,{
	Mov(eax,2)
	call GetLines
	mov ebp,#8
	mov ah,#7
	mov ebx,#4
	mov ecx,#17
	call DumpZone
	})
	add esi,#17*4
	ret

;;;; Print 32 words from esi
ShowWZone:
	pushing(ad,{
	Mov(eax,2)
	call GetLines
	mov ebp,#4
	mov ah,#7
	mov ebx,#2
	mov ecx,#32
	call DumpZone
	})
	add esi,#32*2
	ret

;;;; Print 54 bytes from esi
ShowBZone:
	pushing(ad,{
	mov ecx,#27
	Mov(eax,2)
	call GetLines
	mov ebp,#2
	mov ah,#7
	mov ebx,#1
	call DumpZone
	call DumpZone
	})
	add esi,#54
	ret

ShowLine:
	pushing(ad,{
	call GetLine
	mov ah,#7
	call DumpString
	})
	ret

GetLine:
	Mov(eax,1)

GetLines:
;; wastes eax
;; edi points to the new line
	mov edi,[pmaddr(DumpLine)]
	add edi,eax
	cmp edi,#24
	jb GL_0
	; should scroll
	mov edi,#8
	add edi,eax
GL_0:	mov [pmaddr(DumpLine)],edi
	sub edi,eax
	shl edi,5
	lea edi,[edi+edi*4]
	add edi,[pmaddr(Video_mem_base)]
	ret





Input_Char:
	SHOWL("Press any key                          ",
              "                                       ")

})
dnl
dnl
})dnl --- debug.m4
dnl
